﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2023.1.2),
    on June 28, 2023, at 15:12
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

# --- Import packages ---
from psychopy import locale_setup
from psychopy import prefs
from psychopy import plugins
plugins.activatePlugins()
prefs.hardware['audioLib'] = 'ptb'
prefs.hardware['audioLatencyMode'] = '3'
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

import psychopy.iohub as io
from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2023.1.2'
expName = 'IrInfo'  # from the Builder filename that created this script
expInfo = {
    'participant': f"{randint(0, 999999):06.0f}",
    'session': '001',
}
# --- Show participant info dialog --
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath="C:\\Users\\otavi\\Dropbox\\Master's MAE\\Experiment\\IrInfo2\\IrInfo_lastrun.py",
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# --- Setup the Window ---
win = visual.Window(
    size=[1376, 774], fullscr=True, screen=0, 
    winType='pyglet', allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    backgroundImage='', backgroundFit='none',
    blendMode='avg', useFBO=True, 
    units='height')
win.mouseVisible = False
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# --- Setup input devices ---
ioConfig = {}

# Setup iohub keyboard
ioConfig['Keyboard'] = dict(use_keymap='psychopy')

ioSession = '1'
if 'session' in expInfo:
    ioSession = str(expInfo['session'])
ioServer = io.launchHubServer(window=win, **ioConfig)
eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='iohub')

# --- Initialize components for Routine "trial1" ---
prompt = visual.ImageStim(
    win=win,
    name='prompt', 
    image='figures/prompt1.jpg', mask=None, anchor='center',
    ori=0.0, pos=(-0.40, -0.08), size=(0.5, 0.5),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=0.0)
# Run 'Begin Experiment' code from rateCode
win.color = 'black'
slider_choices = []
timestamps = []
Q = visual.TextStim(win=win, name='Q',
    text='What is the minimum amount of food per day that the capybara needs to feel satiated?',
    font='Open Sans',
    pos=(0, .40), height=0.045, wrapWidth=1.0, ori=0.0, 
    color=[1.0000, 1.0000, 1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
about_slider = visual.TextStim(win=win, name='about_slider',
    text='Click on the slider below to find it out! Use the least amount of attempts you can.',
    font='Open Sans',
    pos=(0, 0.29), height=0.035, wrapWidth=2.0, ori=0.0, 
    color=[1.0000, 1.0000, 1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);
image = visual.ImageStim(
    win=win,
    name='image', 
    image=None, mask=None, anchor='center',
    ori=0, pos=(0.33, -0.11), size=1.0,
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-4.0)
slider = visual.Slider(win=win, name='slider',
    startValue=None, size=(0.6, 0.05), pos=(0.33, 0.17), units=win.units,
    labels=['10','20','30','40','50','60','70','80','90','100','110','120','130'], ticks=(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13), granularity=1.0,
    style='slider', styleTweaks=(), opacity=None,
    labelColor=[0.6549, 0.6549, 0.6549], markerColor=[1.0000, -1.0000, -1.0000], lineColor=[1.0000, 1.0000, 1.0000], colorSpace='rgb',
    font='Open Sans', labelHeight=0.02,
    flip=False, ori=0.0, depth=-5, readOnly=False)
n_attempts = visual.TextStim(win=win, name='n_attempts',
    text='',
    font='Open Sans',
    pos=(0.33, -0.35), height=0.035, wrapWidth=None, ori=0.0, 
    color=[1.0000, 1.0000, 1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-6.0);
key_resp = keyboard.Keyboard()

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.Clock()  # to track time remaining of each (possibly non-slip) routine 

# --- Prepare to start Routine "trial1" ---
continueRoutine = True
# update component parameters for each repeat
# Run 'Begin Routine' code from rateCode
# start rating
attempts = 0
last_rating = None
displayText = ""
slider.reset()
key_resp.keys = []
key_resp.rt = []
_key_resp_allKeys = []
# keep track of which components have finished
trial1Components = [prompt, Q, about_slider, image, slider, n_attempts, key_resp]
for thisComponent in trial1Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "trial1" ---
routineForceEnded = not continueRoutine
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *prompt* updates
    
    # if prompt is starting this frame...
    if prompt.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        prompt.frameNStart = frameN  # exact frame index
        prompt.tStart = t  # local t and not account for scr refresh
        prompt.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(prompt, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'prompt.started')
        # update status
        prompt.status = STARTED
        prompt.setAutoDraw(True)
    
    # if prompt is active this frame...
    if prompt.status == STARTED:
        # update params
        pass
    # Run 'Each Frame' code from rateCode
    if slider.rating is None:  # Before any selection is made
        imageName = 'figures/image0f.png'  # Show the initial image
        image.setImage(imageName)
    elif slider.rating is not None:
        imageIndex = int(slider.getRating()) - 1
        imageName = 'figures/image{}f.png'.format(imageIndex + 1)
        image.setImage(imageName)
    
    if slider.rating is not None and slider.rating != last_rating:
        slider_choices.append(slider.rating)
        timestamps.append(slider.rt)
        attempts += 1
    last_rating = slider.rating  # Store the current rating to compare in the next frame
    displayText = "Number of attempts used: " + str(attempts)
    
    
    # *Q* updates
    
    # if Q is starting this frame...
    if Q.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        Q.frameNStart = frameN  # exact frame index
        Q.tStart = t  # local t and not account for scr refresh
        Q.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Q, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'Q.started')
        # update status
        Q.status = STARTED
        Q.setAutoDraw(True)
    
    # if Q is active this frame...
    if Q.status == STARTED:
        # update params
        pass
    
    # *about_slider* updates
    
    # if about_slider is starting this frame...
    if about_slider.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        about_slider.frameNStart = frameN  # exact frame index
        about_slider.tStart = t  # local t and not account for scr refresh
        about_slider.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(about_slider, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'about_slider.started')
        # update status
        about_slider.status = STARTED
        about_slider.setAutoDraw(True)
    
    # if about_slider is active this frame...
    if about_slider.status == STARTED:
        # update params
        pass
    
    # *image* updates
    
    # if image is starting this frame...
    if image.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        image.frameNStart = frameN  # exact frame index
        image.tStart = t  # local t and not account for scr refresh
        image.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(image, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'image.started')
        # update status
        image.status = STARTED
        image.setAutoDraw(True)
    
    # if image is active this frame...
    if image.status == STARTED:
        # update params
        image.setSize([0.4,0.4], log=False)
    
    # *slider* updates
    
    # if slider is starting this frame...
    if slider.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        slider.frameNStart = frameN  # exact frame index
        slider.tStart = t  # local t and not account for scr refresh
        slider.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(slider, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'slider.started')
        # update status
        slider.status = STARTED
        slider.setAutoDraw(True)
    
    # if slider is active this frame...
    if slider.status == STARTED:
        # update params
        pass
    
    # *n_attempts* updates
    
    # if n_attempts is starting this frame...
    if n_attempts.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        n_attempts.frameNStart = frameN  # exact frame index
        n_attempts.tStart = t  # local t and not account for scr refresh
        n_attempts.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(n_attempts, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'n_attempts.started')
        # update status
        n_attempts.status = STARTED
        n_attempts.setAutoDraw(True)
    
    # if n_attempts is active this frame...
    if n_attempts.status == STARTED:
        # update params
        n_attempts.setText(displayText, log=False)
    
    # *key_resp* updates
    waitOnFlip = False
    
    # if key_resp is starting this frame...
    if key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        key_resp.frameNStart = frameN  # exact frame index
        key_resp.tStart = t  # local t and not account for scr refresh
        key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_resp, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'key_resp.started')
        # update status
        key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_resp.status == STARTED and not waitOnFlip:
        theseKeys = key_resp.getKeys(keyList=['e'], waitRelease=False)
        _key_resp_allKeys.extend(theseKeys)
        if len(_key_resp_allKeys):
            key_resp.keys = _key_resp_allKeys[-1].name  # just the last key pressed
            key_resp.rt = _key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in trial1Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "trial1" ---
for thisComponent in trial1Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# Run 'End Routine' code from rateCode
for choice, timestamp in zip(slider_choices, timestamps):
    thisExp.addData('slider_choice', choice)
    thisExp.addData('response_time', timestamp)
    thisExp.addData('attempts', attempts)
#thisExp.addData('final_rating', slider.rating)
thisExp.addData('slider.response', slider.getRating())
thisExp.addData('slider.rt', slider.getRT())
thisExp.addData('slider.history', slider.getHistory())
# check responses
if key_resp.keys in ['', [], None]:  # No response was made
    key_resp.keys = None
thisExp.addData('key_resp.keys',key_resp.keys)
if key_resp.keys != None:  # we had a response
    thisExp.addData('key_resp.rt', key_resp.rt)
thisExp.nextEntry()
# the Routine "trial1" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- End experiment ---
# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
